<?php

/*
|---------------------------------------------------------------
| HZ FRAMEWORK
|---------------------------------------------------------------
|
| -> PACKAGE / HZ FRAMEWORK
| -> AUTHOR / HASSAN AZZI
| -> DATE / 2015-04-01
| -> CODECANYON / http://codecanyon.net/user/hassanazy
| -> VERSION / 1.0.0
|
|---------------------------------------------------------------
| Copyright (c) 2015 , All rights reserved.
|---------------------------------------------------------------
*/
use Jenssegers\Date\Date;

Date::setLocale(Languages::current_language());

function is_routed($route)
{
    return Check::is_routed($route);
}

function set($key="", $value="")
{
    Sys::set($key, $value);
}

function get($key)
{
    return Sys::get($key);
}

function _get($key)
{
    echo Sys::get($key);
}

function router($route, $params="", $mixed=false, $inside=false)
{
    if(!empty($params) && !is_array($params)):
        $params = json_decode($params, true);
    endif;
    if(empty($params)) $params = array();
    return Template::route($route, $params, $mixed, $inside);
}

function _router($route, $params=array(), $mixed=false, $inside=false)
{
    echo router($route, $params, $mixed, $inside);
}

function to_router($route, $params=array())
{
    $url = Template::route($route, $params);
    header("location: ".$url);
}

function l($key, $value="")
{
    $key = strip_tags($key);
    if(!empty($GLOBALS["_LNG"][$key]))
    {
        return $GLOBALS["_LNG"][$key];
    }
    else
    {
        return $value;
    }
}

function _l($key, $value="")
{
    echo l($key, $value);
}

function _s($key)
{
    echo Settings::get($key);
}

function s($key)
{
    return Settings::get($key);
}

function af($key)
{
    $infos = Auth::user_settings("affiliate");
    return $infos[$key];
}

function _af($key)
{
    echo af($key);
}

function w($key)
{
    $infos = Auth::user_settings("wallet");
    return $infos[$key];
}

function _w($key)
{
    echo w($key);
}

function _old($name="")
{
    echo Request::old($name);
}

function url($op="", $prtcl="", $mixed=false, $inside=false)
{
	return Sys::url($op, $prtcl, $mixed, $inside);
}

function _url($op="", $prtcl="", $mixed=false, $inside=false)
{
	echo url($op, $prtcl, $mixed, $inside);
}

function turl()
{
	return Template::url();
}

function _turl()
{
	echo turl();
}

function u($key="")
{
	$info = Auth::info();
	return $info[$key];
}

function _u($key="")
{
	echo u($key);
}


function auth($table = "users")
{
	return Auth::check($table);
}

function storage($file)
{
	return Sys::url()."/uploads/".$file;
}

function _storage($file)
{
	echo Sys::url()."/uploads/".$file;
}

function gravatar($email, $size=200)
{
    $usersEmail = strip_tags($email);
    $defaultImage = urlencode("http://www.gravatar.com/avatar/ad516503a11cd5ca435acc9bb6523536?size=".$size);
    // Possible values (G, PG, R, X)
    $avatarRating = "G";
    // URL for Gravatar
    $gravatarURL = "http://www.gravatar.com/avatar.php?gravatar_id=".md5($usersEmail).
				   "&default=".$defaultImage.
				   "&size=".$size.
				   "&rating=".$avatarRating;
	return $gravatarURL;
}

function _gravatar($email, $size=200)
{
    echo gravatar($email, $size);
}

function avatar($file="", $email="", $size=200)
{
	$email = strip_tags($email);
	$file = strip_tags($file);
	if(!empty($file))
	{
		return Sys::urlfile($file);
	}
	else
	{
		return gravatar($email, $size);
	}
}

function _avatar($file="", $email="", $size=200)
{
	echo avatar($file, $email, $size);
}

function event($name)
{
	Events::add_event($name);
}

function do_action($name, $on)
{
	Events::do_action($name, $on);
}

function cdate($format, $time="")
{
    if(empty($time)) $time = time();
    return Date::parse($time, $GLOBALS["_SETTINGS"]["TIMEZONE"])->format($format);
}

function time_ago($time)
{
    return Date::parse(floor($time-time())." second", $GLOBALS["_SETTINGS"]["TIMEZONE"])->diffForHumans();
}

function put_recaptcha()
{
    echo '<div class="g-recaptcha" data-sitekey="'.s("recaptcha/publickey").'"></div><script type="text/javascript" src="https://www.google.com/recaptcha/api.js?hl='.Languages::current_language().'"></script>';
}

function check_recaptcha()
{
    $code = Request::post("g-recaptcha-response");
    if(empty($code)) return false;
    $privatekey = s("recaptcha/privatekey");
    $reCAPTCHA = new \ReCaptcha\ReCaptcha($privatekey);
    $resp = $reCAPTCHA->verify($code, Sys::ip());
    if($resp->isSuccess()):
        return true;
    else:
        return false;
    endif;
}

function put_session_key()
{
    $exptime = Encryption::encode(time()+1000);
    $function_name = "S".str_replace(array("_", "/", "-"), "", Encryption::randomstring(8));
    $data = '<script>function '.$function_name.'(n,v,x) { var d = new Date(); d.setTime(d.getTime() + (x*24*60*60*1000)); var ex = "expires="+d.toUTCString(); document.cookie = n + "=" + v + "; path=/; " + ex;} setTimeout(function(){ '.$function_name.'("session_exptime", "'.$exptime.'", 1); }, 1000);</script>';
    echo $data;
}

function check_session_key()
{
    $exptime = Cookie::get("session_exptime");
    $timenow = time();
    if(!empty($exptime) && $exptime > $timenow)
    {
        return true;
    }
    return false;
}

function current_language()
{
    return Languages::current_language();
}

function langauge_align()
{
    return Languages::text_align();
}

function direction()
{
    return Languages::direction();
}

function fv($url)
{
    $prurl = parse_url($url);
    $host = $prurl["host"];
    if(!empty($host))
    {
        $url = "https://www.google.com/s2/favicons?domain=".$host;
        return $url;
    } else {
        return Sys::urlfile("uploads/defaultfavicon.svg");
    }
}

function _fv($url)
{
    echo fv($url);
}
