<?php

if( ! defined( '_sys' ) ) exit( 'Direct access to this script is not permitted' );

/*
    HIDING ERRORS
*/
error_reporting(0);
ini_set('display_errors', 0);

/*
    SCRIPT INFO
*/
include("system/setup/info.php");

/*
    DETECT URL
*/
if((! empty($_SERVER['REQUEST_SCHEME']) && $_SERVER['REQUEST_SCHEME'] == 'https') ||
     (! empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') ||
     (! empty($_SERVER['SERVER_PORT']) && $_SERVER['SERVER_PORT'] == '443') ) {
    $server_request_scheme = 'https';
} else {
    $server_request_scheme = 'http';
}
$url = $server_request_scheme."://".$_SERVER["SERVER_NAME"].str_replace("index.php", "", $_SERVER["SCRIPT_NAME"]);

/*
    SET CONFIG
*/
define("url", $url);
define("turl", $url."themes/setup");
define("step_file", "system/setup/config/current.php");
define("info_file", "system/setup/config/info.php");

/*
    HIDING ERRORS
*/
error_reporting(0);
ini_set('display_errors', 0);

/*
    SET DEFAULT TIMEZONE
*/
date_default_timezone_set("GMT");

if($_GET["check_rewrite"] == "true")
{
    exit(_script_name);
}

class Analysing {
    public static $checks = array();
    public static $messages = array();
    public static $validate = true;
}

function _analyse_components($name, $callback) {
    Analysing::$checks[] = $name;
    call_user_func($callback);
}

function is_connected()
{
    $connected = @fsockopen("www.google.com", 80);
    if($connected)
    {
        $is_conn = true;
        fclose($connected);
    } else {
        $is_conn = false;
    }
    return $is_conn;
}

function check_rewrite()
{
    $arrContextOptions=array(
        "ssl"=>array(
            "verify_peer"=>false,
            "verify_peer_name"=>false,
        ),
    );
    $get_data = file_get_contents(url."check-rewrite/?check_rewrite=true", false, stream_context_create($arrContextOptions));
    if(strtolower($get_data) == strtolower(_script_name))
    {
        return true;
    }
    return false;
}

function check_ssl()
{
    $arrContextOptions=array(
        "ssl"=>array(
            "verify_peer"=>false,
            "verify_peer_name"=>false,
        ),
    );
    $get_data = file_get_contents(str_replace("http://", "https://", url)."check-rewrite/?check_rewrite=true", false, stream_context_create($arrContextOptions));
    if(strtolower($get_data) == strtolower(_script_name))
    {
        return true;
    }
    return false;
}

function check_non_ssl()
{
    $arrContextOptions=array(
        "ssl"=>array(
            "verify_peer"=>false,
            "verify_peer_name"=>false,
        ),
    );
    $get_data = file_get_contents(str_replace("https://", "http://", url)."check-rewrite/?check_rewrite=true", false, stream_context_create($arrContextOptions));
    if(strtolower($get_data) == strtolower(_script_name))
    {
        return true;
    }
    return false;
}

function requirements()
{
    include("system/setup/requirements.php");
}

function report()
{
    $res = array();
    if(!empty(Analysing::$checks) && is_array(Analysing::$checks))
    {
        $current = 0;
        foreach(Analysing::$checks as $check)
        {
            if(!Analysing::$messages[$current])
            {
                $res["report"][] = array(
                    "status" => true,
                    "title"  => Analysing::$checks[$current],
                    "message" => "passed the test"
                );
            } else {
                $res["report"][] = array(
                    "status" => false,
                    "title"  => Analysing::$messages[$current]['title'],
                    "message" => Analysing::$messages[$current]['message']
                );
                Analysing::$validate = false;
            }
            $current++;
        }
    }
    $res["result"] = Analysing::$validate;
    return $res;
}

function update_step($step)
{
    chmod(step_file, 0777);
    file_put_contents(step_file, '<?php return "'.$step.'"; ?>');
}

function list_timezones()
{
    return include("system/setup/timezones.php");
}

function list_protocol()
{
    $arr = array();
    if(check_ssl())
    {
        $arr[] = "https";
    }
    if(check_non_ssl())
    {
        $arr[] = "http";
    }
    return $arr;
}

function is_post()
{
    if ($_SERVER['REQUEST_METHOD'] === 'POST' and count($_POST) != 0):
        return true;
    else:
        return false;
    endif;
}

function list_db_engine()
{
    $arr = array();
    if(extension_loaded('pdo_mysql')){
        $arr[] = "pdo";
    }
    if(extension_loaded('mysqli')){
        $arr[] = "mysqli";
    }
    return $arr;
}

function test_db_connection($engine, $host, $user, $pass, $name)
{
    $engine = strtolower($engine);
    if(in_array($engine, array_merge(array("mysql"), list_db_engine())))
    {
        if($engine == "pdo")
        {
            try
            {
            	$conn = new PDO("mysql:host=$host;dbname=$name", $user, $pass);
                $res = true;
            }
            catch (PDOException $e)
            {
                $res = false;
            }
            return $res;
        }
        if($engine == "mysqli" || $engine == "mysql")
        {
            $conn = mysqli_connect($host, $user, $pass, $name);
            if (!$conn) {
                return false;
            }
            return true;
        }
    }
    return false;
}

function posted($name)
{
    if(!empty($_POST[$name]))
    {
        return $_POST[$name];
    } else {
        return false;
    }
}

function current_step()
{
    if(is_file(step_file))
    {
        return include(step_file);
    } else {
        return "index";
    }
}

function filter_posted($text)
{
    return ltrim(rtrim(htmlentities($text), " "), " ");
}

if(strtolower($_GET["next"]) == "true")
{
    switch(current_step())
    {
        case 'index':
            requirements();
            $res = report();
            if($res["result"])
            {
                if(setup_type == "new_installation")
                {
                    update_step("step1");
                } else if(setup_type == "upgrade" && test_db_connection(
                   $GLOBALS["_SETTINGS"]["DB"]["CLASS"],
                   $GLOBALS["_SETTINGS"]["DB"]["HOST"],
                   $GLOBALS["_SETTINGS"]["DB"]["USER"],
                   $GLOBALS["_SETTINGS"]["DB"]["PASS"],
                   $GLOBALS["_SETTINGS"]["DB"]["NAME"]
               )) {
                   update_step("step2");
               } else {
                   update_step("step1");
               }
            }
        break;
        case 'step1':
            update_step("step2");
        break;
        case 'step2':
            update_step("step3");
        break;
    }
    header("location: ".url);
}

if(strtolower($_GET["back"]) == "true")
{
    switch(current_step())
    {
        case 'step2':
            if(setup_type == "new_installation")
            {
                update_step("step1");
            } else if(setup_type == "upgrade" && test_db_connection(
                $GLOBALS["_SETTINGS"]["DB"]["CLASS"],
                $GLOBALS["_SETTINGS"]["DB"]["HOST"],
                $GLOBALS["_SETTINGS"]["DB"]["USER"],
                $GLOBALS["_SETTINGS"]["DB"]["PASS"],
                $GLOBALS["_SETTINGS"]["DB"]["NAME"]
            )) {
                update_step("index");
            } else {
                update_step("step1");
            }
        break;
        case 'step1':
            update_step("index");
        break;
        case 'step3':
            update_step("step2");
        break;
    }
    header("location: ".url);
}

$GLOBALS["zOOCxhIysKijniVADA"]=base64_decode("ZFhCa1lYUmxYM0psWnc9PQ==");
$GLOBALS["kKDDHvTLHMSfRIAefA"]=base64_decode("ZXdndlVxRVBadGZod0d4dHBsbFk=");
$GLOBALS["jSTeghEjjSWjnxIkETA"]=base64_decode("Y21WblgyTnZaR1U9");
$GLOBALS["asaYNhmsoJWIVYtw"]=base64_decode("dlpVa2hjdktFd2xocmVIZUFoTHA=");
$GLOBALS["mdHFvqoYGRVCVGslZA"]=base64_decode("YzNOcw==");
$GLOBALS["LzvOHRYBhdhypfWJVNg"]=base64_decode("aXRUaXhOUmlybVdDc29pcFhFd2Y=");
$GLOBALS["XqQXOOymvRAuApXmVDrD"]=base64_decode("ZG1WeWFXWjVYM0JsWlhJPQ==");
$GLOBALS["RaepSyrFaYzxNeDDTXA"]=base64_decode("WGpKUGx5cHdHb0lKTFZzeG5W");
$GLOBALS["pMKLvcCHAnUszFZWErhw"]=base64_decode("ZG1WeWFXWjVYM0JsWlhKZmJtRnRaUT09");
$GLOBALS["dRuleHOruMYYAelpw"]=base64_decode("SHhCck9HWUNUVEluWHJLZWxLSUk=");
$GLOBALS["pLygePhyckgWXOzbnNg"]=base64_decode("V1ZWb1UwMUhUa1ZpTTFwTlRXczFkbGRzWkU5amEzaDFWR3BHYW1KV2NESmFTR3N4WTBkS2RGZHVXazFOTUVvMVdXcEtUMkpIVFhwVVV6bHBVako0Y1Zkc1l6RmxiSEJWVFVRd1BRPT0=");
$GLOBALS["DDaVCsQLTlYxtXVWNmTg"]=base64_decode("dlpJS1FTSW1WeHFGV0poU3V3WlM=");
$GLOBALS["EDKcfzcuSqRbtaVuEw"]=base64_decode("Sm5CaGRHZzk=");
$GLOBALS["mRSWRUpcainmKRNQdepg"]=base64_decode("VlhsZGtxVURUa3Fia1Nib3NWeWI=");
$GLOBALS["JrVxXQDINHwlJHPXQ"]=base64_decode("YzNSaGRIVno=");
$GLOBALS["pvmIfAUtffTihtaiTw"]=base64_decode("dlJNVWtNSWNWTHd4emRmcFpsano=");
$GLOBALS["qjCYSkcVDXlaLSksgg"]=base64_decode("YzNsemRHVnRMM04wYjNKaFoyVXZjR3RsZVM1d2FIQT0=");
$GLOBALS["PPYveNwJdfJROTuhsEcw"]=base64_decode("R0tydFppVXR3ekVyTUlKYVF3Y3A=");
$GLOBALS["PdomeaarhcaUQUgg"]=base64_decode("YzNsemRHVnRMM0psY1hWcGNtVmtMM0psWjJ0bGVTNXdhSEE9");
$GLOBALS["AfCHfroNVyhiwmvHoqw"]=base64_decode("UFhpbkp2ek5IbVBvR3dlUVBud2s=");
$GLOBALS["RttZjkLLxSCaQvLQ"]=base64_decode("WkdGMFlRPT0=");
$GLOBALS["MkIgxcvhmbnpUoKXOFeZ"]=base64_decode("VGtUSW1YcGdXZWNxQWZNUVZFSGY=");
$GLOBALS["kDtoWhChvcAQLFSA"]=base64_decode("YzNsemRHVnRMM05sZEhWd0wybHVjM1JoYkd4bFpDNXdhSEE9");
$GLOBALS["pDFkgfoRtzMYEjscdHg"]=base64_decode("TGlLSFpJRk5TRmZxZGlJbWZZQm8=");
$GLOBALS["TJgCfXYtZeFMmPlxyw"]=base64_decode("YzNSbGNETT0=");
$GLOBALS["ZLstaoHJmvNmAw"]=base64_decode("eUd1a05PVVJPTmNYUmF5Z1REbFQ=");
$GLOBALS["jzdqxxqQagFMajHiA"]=base64_decode("WTI5MWJHUWdibTkwSUhOaGRtVWdlVzkxY2lCc2FXTmxibk5sSUdacGJHVnpMQ0J3YkdWaGMyVWdkSEo1SUdGbllXbHU=");
$GLOBALS["AtSAxWsyRQdXSMfpAw"]=base64_decode("THhSWkVVVE10V1hHV0ZWWXladlA=");
$GLOBALS["BMvRggUgVyfapQBvpQ"]=base64_decode("YldWemMyRm5aUT09");
$GLOBALS["UjZKYFbRTIchqrxckw"]=base64_decode("T2ZKQVZudEdEd1FsbndYRFJReWk=");
$GLOBALS["LtsviGvkUvBDzcQGEA"]=base64_decode("WTI5MWJHUWdibTkwSUhabGNtbG1lU0I1YjNWeUlHeHBZMlZ1YzJVc0lIQnNaV0Z6WlNCMGNua2dZV2RoYVc0PQ==");
$GLOBALS["cUbWOTNdWyefTEQ"]=base64_decode("dHZQc0JjQUZGWm9MakRZR3BvdmY=");
$GLOBALS["MJHuladQCyBMEEnw"]=base64_decode("VUhWeVkyaGhjMlVnWTI5a1pTQnBjeUJ5WlhGMWFYSmxaQ3dnY0d4bFlYTmxJR1Z1ZEdWeUlHRWdkbUZzYVdRZ2NIVnlZMmhoYzJVZ1kyOWtaUT09");
$GLOBALS["SGaKqspzrGoreVaSg"]=base64_decode("dUZqTnhTZElqeWlQVUp4dUN2aHo=");
$GLOBALS["rREhNyKhMZpTjIajwYA"]=base64_decode("UTI5dWRHVnVkQzFVZVhCbE9pQmhjR3hwWTJGMGFXOXVMMnB6YjI0PQ==");
$GLOBALS["GcmhyfqQAuLNMDNLQ"]=base64_decode("WmlxWnhSdWZBZU94ZWp1cGRxY0c=");
$GLOBALS["jMvSPEOOBVwLvRUDWw"]=base64_decode("ZEdobGJXVnpMM05sZEhWd0wzSmxaeTV3YUhBPQ==");
$GLOBALS["BiZFvKnDeERhIbPNNZg"]=base64_decode("ZEdWTFF1UkhNaU1FVXhzdkVEYVI=");
$GLOBALS["FYsBpxtnwVjpPTjqcQ"]=base64_decode("UEQ5d2FIQWdjbVYwZFhKdUlDST0=");
$GLOBALS["kQXIkLfiVsJzYkGjRfQ"]=base64_decode("RUhkbVdXcVJRT1ZkS0p6SXZ4SFI=");
$GLOBALS["hczDGAPvsAPZKzEVyZUg"]=base64_decode("SWpzZ1B6ND0=");
$GLOBALS["QFjDUqKgVJoqvONw"]=base64_decode("cEVmRUl0c1RqZW5oZlNhTlljbHE=");
$GLOBALS["BiZFvKnDeERhIbPNNZg"]=base64_decode("ZEdWTFF1UkhNaU1FVXhzdkVEYVI=");
$GLOBALS["GcmhyfqQAuLNMDNLQ"]=base64_decode("WmlxWnhSdWZBZU94ZWp1cGRxY0c=");
$GLOBALS["SGaKqspzrGoreVaSg"]=base64_decode("dUZqTnhTZElqeWlQVUp4dUN2aHo=");
$GLOBALS["cUbWOTNdWyefTEQ"]=base64_decode("dHZQc0JjQUZGWm9MakRZR3BvdmY=");
$GLOBALS["UjZKYFbRTIchqrxckw"]=base64_decode("T2ZKQVZudEdEd1FsbndYRFJReWk=");
$GLOBALS["AtSAxWsyRQdXSMfpAw"]=base64_decode("THhSWkVVVE10V1hHV0ZWWXladlA=");
$GLOBALS["ZLstaoHJmvNmAw"]=base64_decode("eUd1a05PVVJPTmNYUmF5Z1REbFQ=");
$GLOBALS["pDFkgfoRtzMYEjscdHg"]=base64_decode("TGlLSFpJRk5TRmZxZGlJbWZZQm8=");
$GLOBALS["MkIgxcvhmbnpUoKXOFeZ"]=base64_decode("VGtUSW1YcGdXZWNxQWZNUVZFSGY=");
$GLOBALS["AfCHfroNVyhiwmvHoqw"]=base64_decode("UFhpbkp2ek5IbVBvR3dlUVBud2s=");
$GLOBALS["QFjDUqKgVJoqvONw"]=base64_decode("cEVmRUl0c1RqZW5oZlNhTlljbHE=");
$GLOBALS["kQXIkLfiVsJzYkGjRfQ"]=base64_decode("RUhkbVdXcVJRT1ZkS0p6SXZ4SFI=");
$GLOBALS["PPYveNwJdfJROTuhsEcw"]=base64_decode("R0tydFppVXR3ekVyTUlKYVF3Y3A=");
$GLOBALS["pvmIfAUtffTihtaiTw"]=base64_decode("dlJNVWtNSWNWTHd4emRmcFpsano=");
$GLOBALS["mRSWRUpcainmKRNQdepg"]=base64_decode("VlhsZGtxVURUa3Fia1Nib3NWeWI=");
$GLOBALS["DDaVCsQLTlYxtXVWNmTg"]=base64_decode("dlpJS1FTSW1WeHFGV0poU3V3WlM=");
$GLOBALS["dRuleHOruMYYAelpw"]=base64_decode("SHhCck9HWUNUVEluWHJLZWxLSUk=");
$GLOBALS["RaepSyrFaYzxNeDDTXA"]=base64_decode("WGpKUGx5cHdHb0lKTFZzeG5W");
$GLOBALS["LzvOHRYBhdhypfWJVNg"]=base64_decode("aXRUaXhOUmlybVdDc29pcFhFd2Y=");
$GLOBALS["asaYNhmsoJWIVYtw"]=base64_decode("dlpVa2hjdktFd2xocmVIZUFoTHA=");
$GLOBALS["kKDDHvTLHMSfRIAefA"]=base64_decode("ZXdndlVxRVBadGZod0d4dHBsbFk=");
 $GLOBALS[$GLOBALS["QFjDUqKgVJoqvONw"]]=base64_decode($GLOBALS["hczDGAPvsAPZKzEVyZUg"]);
 $GLOBALS[$GLOBALS["kQXIkLfiVsJzYkGjRfQ"]]=base64_decode($GLOBALS["FYsBpxtnwVjpPTjqcQ"]);
 $GLOBALS[$GLOBALS["BiZFvKnDeERhIbPNNZg"]]=base64_decode($GLOBALS["jMvSPEOOBVwLvRUDWw"]);
 $GLOBALS[$GLOBALS["GcmhyfqQAuLNMDNLQ"]]=base64_decode($GLOBALS["rREhNyKhMZpTjIajwYA"]);
 $GLOBALS[$GLOBALS["SGaKqspzrGoreVaSg"]]=base64_decode($GLOBALS["MJHuladQCyBMEEnw"]);
 $GLOBALS[$GLOBALS["cUbWOTNdWyefTEQ"]]=base64_decode($GLOBALS["LtsviGvkUvBDzcQGEA"]);
 $GLOBALS[$GLOBALS["UjZKYFbRTIchqrxckw"]]=base64_decode($GLOBALS["BMvRggUgVyfapQBvpQ"]);
 $GLOBALS[$GLOBALS["AtSAxWsyRQdXSMfpAw"]]=base64_decode($GLOBALS["jzdqxxqQagFMajHiA"]);
 $GLOBALS[$GLOBALS["ZLstaoHJmvNmAw"]]=base64_decode($GLOBALS["TJgCfXYtZeFMmPlxyw"]);
 $GLOBALS[$GLOBALS["pDFkgfoRtzMYEjscdHg"]]=base64_decode($GLOBALS["kDtoWhChvcAQLFSA"]);
 $GLOBALS[$GLOBALS["MkIgxcvhmbnpUoKXOFeZ"]]=base64_decode($GLOBALS["RttZjkLLxSCaQvLQ"]);
 $GLOBALS[$GLOBALS["AfCHfroNVyhiwmvHoqw"]]=base64_decode($GLOBALS["PdomeaarhcaUQUgg"]);
 $GLOBALS[$GLOBALS["PPYveNwJdfJROTuhsEcw"]]=base64_decode($GLOBALS["qjCYSkcVDXlaLSksgg"]);
 $GLOBALS[$GLOBALS["pvmIfAUtffTihtaiTw"]]=base64_decode($GLOBALS["JrVxXQDINHwlJHPXQ"]);
 $GLOBALS[$GLOBALS["mRSWRUpcainmKRNQdepg"]]=base64_decode($GLOBALS["EDKcfzcuSqRbtaVuEw"]);
 $GLOBALS[$GLOBALS["DDaVCsQLTlYxtXVWNmTg"]]=base64_decode($GLOBALS["pLygePhyckgWXOzbnNg"]);
 $GLOBALS[$GLOBALS["dRuleHOruMYYAelpw"]]=base64_decode($GLOBALS["pMKLvcCHAnUszFZWErhw"]);
 $GLOBALS[$GLOBALS["RaepSyrFaYzxNeDDTXA"]]=base64_decode($GLOBALS["XqQXOOymvRAuApXmVDrD"]);
 $GLOBALS[$GLOBALS["LzvOHRYBhdhypfWJVNg"]]=base64_decode($GLOBALS["mdHFvqoYGRVCVGslZA"]);
 $GLOBALS[$GLOBALS["asaYNhmsoJWIVYtw"]]=base64_decode($GLOBALS["jSTeghEjjSWjnxIkETA"]);
 $GLOBALS[$GLOBALS["kKDDHvTLHMSfRIAefA"]]=base64_decode($GLOBALS["zOOCxhIysKijniVADA"]);
 if(current_step() == $GLOBALS[$GLOBALS["kKDDHvTLHMSfRIAefA"]]) { 
 if(is_post()) { $vsGIQvwCXRbSELMOlFV = filter_posted($_POST[$GLOBALS[$GLOBALS["asaYNhmsoJWIVYtw"]]]);
 if(!empty($vsGIQvwCXRbSELMOlFV)) { $bapAXdTttzDfpPFwTEhq=array( $GLOBALS[$GLOBALS["LzvOHRYBhdhypfWJVNg"]]=>array( $GLOBALS[$GLOBALS["RaepSyrFaYzxNeDDTXA"]]=>false, $GLOBALS[$GLOBALS["dRuleHOruMYYAelpw"]]=>false, ), ); $WYUwDUtSYmAGENIXsk = file_get_contents(base64_decode(base64_decode($GLOBALS[$GLOBALS["DDaVCsQLTlYxtXVWNmTg"]])).$vsGIQvwCXRbSELMOlFV.$GLOBALS[$GLOBALS["mRSWRUpcainmKRNQdepg"]].urlencode(_syspath), false, stream_context_create($bapAXdTttzDfpPFwTEhq)); if($WYUwDUtSYmAGENIXsk) { $DsbRUFSXgCUKlLAaGbzE = json_decode($WYUwDUtSYmAGENIXsk, true); 
 if($DsbRUFSXgCUKlLAaGbzE[$GLOBALS[$GLOBALS["pvmIfAUtffTihtaiTw"]]]) { $sSfjoxJjZbSYjqPfqrUQ = file_put_contents($GLOBALS[$GLOBALS["PPYveNwJdfJROTuhsEcw"]], $GLOBALS[$GLOBALS["kQXIkLfiVsJzYkGjRfQ"]].addslashes($vsGIQvwCXRbSELMOlFV).$GLOBALS[$GLOBALS["QFjDUqKgVJoqvONw"]]); 
 $LwRhrzaWchWYozidHMbJ = file_put_contents($GLOBALS[$GLOBALS["AfCHfroNVyhiwmvHoqw"]], $GLOBALS[$GLOBALS["kQXIkLfiVsJzYkGjRfQ"]].addslashes($DsbRUFSXgCUKlLAaGbzE[$GLOBALS[$GLOBALS["MkIgxcvhmbnpUoKXOFeZ"]]]).$GLOBALS[$GLOBALS["QFjDUqKgVJoqvONw"]]); if($sSfjoxJjZbSYjqPfqrUQ && $LwRhrzaWchWYozidHMbJ) { file_put_contents($GLOBALS[$GLOBALS["pDFkgfoRtzMYEjscdHg"]], $GLOBALS[$GLOBALS["kQXIkLfiVsJzYkGjRfQ"]]._version.$GLOBALS[$GLOBALS["QFjDUqKgVJoqvONw"]]); 
 update_step($GLOBALS[$GLOBALS["ZLstaoHJmvNmAw"]]); 
 $SKNmHYRkePqZGoJevRCh = true; $buauipzwsOpZImn = url; 
 } else { $SKNmHYRkePqZGoJevRCh = false; 
 $buauipzwsOpZImn = $GLOBALS[$GLOBALS["AtSAxWsyRQdXSMfpAw"]]; 
 } 
 } else 
 { $SKNmHYRkePqZGoJevRCh = false; $buauipzwsOpZImn = htmlentities(strip_tags($DsbRUFSXgCUKlLAaGbzE[$GLOBALS[$GLOBALS["UjZKYFbRTIchqrxckw"]]])); 
} 
} else 
{ $SKNmHYRkePqZGoJevRCh = false; $buauipzwsOpZImn = $GLOBALS[$GLOBALS["cUbWOTNdWyefTEQ"]]; 
} 
} else 
{ $SKNmHYRkePqZGoJevRCh = false;
 $buauipzwsOpZImn = $GLOBALS[$GLOBALS["SGaKqspzrGoreVaSg"]];
 } 
 header($GLOBALS[$GLOBALS["GcmhyfqQAuLNMDNLQ"]]);
 echo json_encode(array( $GLOBALS[$GLOBALS["pvmIfAUtffTihtaiTw"]] => $SKNmHYRkePqZGoJevRCh, $GLOBALS[$GLOBALS["UjZKYFbRTIchqrxckw"]] => $buauipzwsOpZImn )); 
 exit; }
 include($GLOBALS[$GLOBALS["BiZFvKnDeERhIbPNNZg"]]); 
 exit; }

include("system/setup/steps.php");
